﻿using System.Collections.Generic;
using thebasics.Models;
using thebasics.ModSystems.PlayerStats.Models;

namespace thebasics.Configs
{
    public class ModConfig
    {
        public IDictionary<ProximityChatMode, int> ProximityChatModeDistances = new Dictionary<ProximityChatMode, int>
        {
            {ProximityChatMode.Yell, 90},
            {ProximityChatMode.Normal, 35},
            {ProximityChatMode.Whisper, 5},
            {ProximityChatMode.Sign, 15}
        };

        public bool BoldNicknames = false;

        public IDictionary<ProximityChatMode, string[]> ProximityChatModeVerbs =
            new Dictionary<ProximityChatMode, string[]>
            {
                {ProximityChatMode.Yell, new[] {"yells", "shouts", "exclaims"}},
                {ProximityChatMode.Normal, new[] {"says", "states", "mentions"}},
                {ProximityChatMode.Whisper, new[] {"whispers", "mumbles", "mutters"}},
                {ProximityChatMode.Sign, new[] {"signs", "gestures", "motions"}}
            };

        public IDictionary<ProximityChatMode, string> ProximityChatModePunctuation =
            new Dictionary<ProximityChatMode, string>
            {
                {ProximityChatMode.Yell, "!"},
                {ProximityChatMode.Normal, "."},
                {ProximityChatMode.Whisper, "."},
                {ProximityChatMode.Sign, "."}
            };

        public IDictionary<ProximityChatMode, string> ProximityChatModeQuotationStart =
            new Dictionary<ProximityChatMode, string>
            {
                {ProximityChatMode.Yell, "\""},
                {ProximityChatMode.Normal, "\""},
                {ProximityChatMode.Whisper, "\""},
                {ProximityChatMode.Sign, "<i>\'"}
            };

        public IDictionary<ProximityChatMode, string> ProximityChatModeQuotationEnd =
            new Dictionary<ProximityChatMode, string>
            {
                {ProximityChatMode.Yell, "\""},
                {ProximityChatMode.Normal, "\""},
                {ProximityChatMode.Whisper, "\""},
                {ProximityChatMode.Sign, "\'</i>"}
            };

        public bool SendServerSaveAnnouncement = true;
        public bool SendServerSaveFinishedAnnouncement = false;

        public string TEXT_ServerSaveAnnouncement = "Server save has started - expect lag for a few seconds.";
        public string TEXT_ServerSaveFinished = "Server save has finished.";

        public bool PlayerStatSystem = true;
        public IDictionary<PlayerStatType, bool> PlayerStatToggles = new Dictionary<PlayerStatType, bool>
        {
            {PlayerStatType.Deaths, true},
            {PlayerStatType.NpcKills, true},
            {PlayerStatType.PlayerKills, true},
        };

        public bool AllowPlayerTpa = true;
        public bool AllowTpaPrivilegeByDefault = false;
        public bool TpaUseCooldown = false;
        public double TpaCooldownInGameHours = 0.5;
        // public bool TpaUseExpiration = true;
        // public double TpaExpirationInGameHours = 0.5;
        // public bool LogTpaToAdminChat = true;

        public bool EnableSleepNotifications = true;
        public double SleepNotificationThreshold = 0.5;
        public string TEXT_SleepNotification = "You start to feel tired...";
    }
}